﻿// <auto-generated />

using System;
using System.Linq;
using System.Text;
using System.Collections;
using System.Reflection;
using System.Collections.Generic;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using Microsoft.Crm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Metadata;
using System.ComponentModel;

[assembly: Microsoft.Xrm.Sdk.Client.ProxyTypesAssemblyAttribute()]
namespace ProxyClassNameSpace
{
    public abstract partial class BaseProxyClass : Entity, INotifyPropertyChanged, INotifyPropertyChanging
    {
        protected BaseProxyClass(Entity original)
        {
            if (string.IsNullOrEmpty(original.LogicalName)) { throw new Exception("Please specify the 'logicalName' on the entity when using a proxy class."); }
            this.LogicalName = GetLogicalName(this.GetType());
            if (this.LogicalName != original.LogicalName) { throw new Exception("Please make sure that the entity logical name matches that of the proxy class you are creating."); }

            this.LogicalName = original.LogicalName;
            this.RelatedEntities.Clear();
            this.FormattedValues.Clear();
            this.Attributes.Clear();
            this.RelatedEntities.AddRange(original.RelatedEntities);
            this.FormattedValues.AddRange(original.FormattedValues);
            this.ExtensionData = original.ExtensionData;
            this.Attributes.AddRange(original.Attributes);
            this.EntityState = original.EntityState;
            this.Id = original.Id;
        }
        public static bool ReturnDatesInLocalTime = false;
        public Guid Create(IOrganizationService service)
        {
            this.Id = service.Create(this);
            _changedValues.Clear();
            return this.Id;
        }
        public void Delete(IOrganizationService service)
        {
            service.Delete(this.LogicalName, this.Id);
        }
        public void Update(IOrganizationService service)
        {
            if (_changedValues.Count > 0)
                service.Update(GetChangedEntity());
            _changedValues.Clear();
        }
        public async System.Threading.Tasks.Task<Guid> CreateAsync(IOrganizationService service)
        {
            return await System.Threading.Tasks.Task.Run(() => { return this.Create(service); });
        }
        public async System.Threading.Tasks.Task UpdateAsync(IOrganizationService service)
        {
            await System.Threading.Tasks.Task.Run(() => { this.Update(service); });
        }
        public async System.Threading.Tasks.Task DeleteAsync(IOrganizationService service)
        {
            await System.Threading.Tasks.Task.Run(() => { this.Delete(service); });
        }
        public Entity GetChangedEntity()
        {
            var entity = new Entity(this.LogicalName);
            entity.Id = this.Id;
            foreach (string attributeName in _changedValues.Keys)
                entity.Attributes[attributeName] = this.Attributes[attributeName];
            return entity;
        }
        public void Save(IOrganizationService service)
        {
            if (this.Id != Guid.Empty) { this.Update(service); }
            else { this.Create(service); }
        }
        public async System.Threading.Tasks.Task SaveAsync(IOrganizationService service)
        {
            await System.Threading.Tasks.Task.Run(() => { this.Save(service); });
        }
        public static BaseProxyClass CreateProxyType(Entity entity)
        {
            if (!_proxyTypes.ContainsValue(entity.LogicalName))
                //Register all the types in the current assembly
                RegisterProxyTypesInAssembly(typeof(BaseProxyClass).Assembly);

            if (_proxyTypes.ContainsValue(entity.LogicalName))
            {
                var proxyType = (from ProxyTypeTemp in _proxyTypes.Keys where _proxyTypes[ProxyTypeTemp] == entity.LogicalName select ProxyTypeTemp).FirstOrDefault();
                var ConstructorTemp = proxyType.GetConstructor(new Type[] { typeof(Entity) });
                return (BaseProxyClass)ConstructorTemp.Invoke(new object[] { entity });
            }
            else
                throw new Exception("The proxy class for type '" + entity.LogicalName + "' has not been registered.");
        }
        private static Dictionary<Type, string> _proxyTypes = new Dictionary<Type, string>();
        public static void RegisterProxyType(Type ProxyType, string logicalName)
        {
            if (!_proxyTypes.ContainsKey(ProxyType)) { _proxyTypes.Add(ProxyType, logicalName); }
        }
        public static void RegisterProxyTypesInAssembly(Assembly assembly)
        {
            if (assembly != null)
            {
                foreach (var type in assembly.GetTypes())
                    System.Runtime.CompilerServices.RuntimeHelpers.RunClassConstructor(type.TypeHandle);
            }
        }
        public static string GetLogicalName<T>() where T : BaseProxyClass
        {
            return GetLogicalName(typeof(T));
        }
        public static string GetLogicalName(Type type)
        {
            if (!_proxyTypes.ContainsKey(type))
            {
                //This forces the static constructor to be called and register the name
                ConstructorInfo constructor = type.GetConstructor(new Type[] { });
                constructor.Invoke(new object[] { });
            }
            return _proxyTypes[type];
        }
        public static implicit operator EntityReference(BaseProxyClass proxy)
        {
            if (proxy != null) { return proxy.ToEntityReference(); }
            return null;
        }
        public T GetPropertyValue<T>(string name)
        {
            if (this.Contains(name))
            {
                var value = (T)this.Attributes[name];
                if ((typeof(T) == typeof(DateTime) || typeof(T) == typeof(DateTime?)) && ReturnDatesInLocalTime && value != null)
                    value = (T)(Object)((DateTime)(Object)value).ToLocalTime();
                return value;
            }
            return default(T);
        }
        //dictionary of values that have changed along with the original value
        Dictionary<string, object> _changedValues = new Dictionary<string, object>();
        AttributeEqualityComparer _equalityComparer = new AttributeEqualityComparer();
        public void SetPropertyValue<T>(string name, T value, string propertyName)
        {
            if (_changedValues.ContainsKey(name))
            {
                var originalValue = _changedValues[name];
                var currentValue = this.Contains(name) ? (object)this.GetPropertyValue<T>(name) : null;
                if (!_equalityComparer.Equals(currentValue, value))
                {
                    OnPropertyChanging(propertyName);
                    if (_equalityComparer.Equals(originalValue, value)) { _changedValues.Remove(name); }
                    this.Attributes[name] = value;
                    OnPropertyChanged(propertyName);
                }
            }
            else
            {
                var currentValue = this.Contains(name) ? (object)this.GetPropertyValue<T>(name) : null;
                if (!_equalityComparer.Equals(currentValue, value))
                {
                    OnPropertyChanging(propertyName);
                    _changedValues.Add(name, currentValue);
                    this.Attributes[name] = value;
                    OnPropertyChanged(propertyName);
                }
            }
        }
        private void OnPropertyChanging(string propertyName)
        {
            if (this.PropertyChanging != null) { this.PropertyChanging(this, new PropertyChangingEventArgs(propertyName)); }
        }
        private void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null) { this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName)); }
        }
        public void SetPropertyValue(string name, string value, int maxLength, string propertyName)
        {
            var textOptions = GetTextOptions(name);
            if (textOptions != eTextOptions.Ignore && !string.IsNullOrEmpty(value) && value.Length > maxLength)
            {
                if (textOptions == eTextOptions.Truncate) { value = value.Substring(0, maxLength); }
                else { throw new Exception(string.Format(GetErrorString(name, eErrorType.Text), name, value, value.Length, maxLength)); }
            }
            SetPropertyValue<string>(name, value, propertyName);
        }
        public void SetPropertyValue(string name, int? value, int minValue, int maxValue, string propertyName)
        {
            var numberOptions = GetNumberOptions(name);
            if (numberOptions != eNumberOptions.Ignore && (value < minValue || value > maxValue))
            {
                bool throwError = false;
                if (numberOptions == eNumberOptions.CorrectMinAndMax) { value = (value < minValue) ? minValue : maxValue; }
                else if (numberOptions == eNumberOptions.CorrectMinIgnoreMax) { value = (value < minValue) ? minValue : value; }
                else if (numberOptions == eNumberOptions.CorrectMinThrowMax && value < minValue) { value = minValue; }
                else if (numberOptions == eNumberOptions.CorrectMaxIgnoreMin) { value = (value > maxValue) ? maxValue : value; }
                else if (numberOptions == eNumberOptions.CorrectMaxThrowMin && value > maxValue) { value = maxValue; }
                else { throwError = true; }
                if (throwError) { throw new Exception(string.Format(GetErrorString(name, eErrorType.Number), name, value, minValue, maxValue)); }
            }
            SetPropertyValue(name, value, propertyName);
        }
        public void SetPropertyValue(string name, decimal? value, decimal minValue, decimal maxValue, string propertyName)
        {
            var numberOptions = GetNumberOptions(name);
            if (numberOptions != eNumberOptions.Ignore && (value < minValue || value > maxValue))
            {
                bool throwError = false;
                if (numberOptions == eNumberOptions.CorrectMinAndMax) { value = (value < minValue) ? minValue : maxValue; }
                else if (numberOptions == eNumberOptions.CorrectMinIgnoreMax) { value = (value < minValue) ? minValue : value; }
                else if (numberOptions == eNumberOptions.CorrectMinThrowMax && value < minValue) { value = minValue; }
                else if (numberOptions == eNumberOptions.CorrectMaxIgnoreMin) { value = (value > maxValue) ? maxValue : value; }
                else if (numberOptions == eNumberOptions.CorrectMaxThrowMin && value > maxValue) { value = maxValue; }
                else { throwError = true; }
                if (throwError) { throw new Exception(string.Format(GetErrorString(name, eErrorType.Number), name, value, minValue, maxValue)); }
            }
            SetPropertyValue(name, value, propertyName);
        }
        public void SetPropertyValue(string name, double? value, double minValue, double maxValue, string propertyName)
        {
            var numberOptions = GetNumberOptions(name);
            if (numberOptions != eNumberOptions.Ignore && (value < minValue || value > maxValue))
            {
                bool throwError = false;
                if (numberOptions == eNumberOptions.CorrectMinAndMax) { value = (value < minValue) ? minValue : maxValue; }
                else if (numberOptions == eNumberOptions.CorrectMinIgnoreMax) { value = (value < minValue) ? minValue : value; }
                else if (numberOptions == eNumberOptions.CorrectMinThrowMax && value < minValue) { value = minValue; }
                else if (numberOptions == eNumberOptions.CorrectMaxIgnoreMin) { value = (value > maxValue) ? maxValue : value; }
                else if (numberOptions == eNumberOptions.CorrectMaxThrowMin && value > maxValue) { value = maxValue; }
                else { throwError = true; }
                if (throwError) { throw new Exception(string.Format(GetErrorString(name, eErrorType.Number), name, value, minValue, maxValue)); }
            }
            SetPropertyValue(name, value, propertyName);
        }
        public void SetPropertyValue(string name, Money value, decimal minValue, decimal maxValue, string propertyName)
        {
            var numberOptions = GetNumberOptions(name);
            if (value != null && numberOptions != eNumberOptions.Ignore && (value.Value < minValue || value.Value > maxValue))
            {
                bool throwError = false;
                if (numberOptions == eNumberOptions.CorrectMinAndMax) { value.Value = (value.Value < minValue) ? minValue : maxValue; }
                else if (numberOptions == eNumberOptions.CorrectMinIgnoreMax) { value.Value = (value.Value < minValue) ? minValue : value.Value; }
                else if (numberOptions == eNumberOptions.CorrectMinThrowMax && value.Value < minValue) { value.Value = minValue; }
                else if (numberOptions == eNumberOptions.CorrectMaxIgnoreMin) { value.Value = (value.Value > maxValue) ? maxValue : value.Value; }
                else if (numberOptions == eNumberOptions.CorrectMaxThrowMin && value.Value > maxValue) { value.Value = maxValue; }
                else { throwError = true; }
                if (throwError) { throw new Exception(string.Format(GetErrorString(name, eErrorType.Number), name, value.Value, minValue, maxValue)); }
            }
            SetPropertyValue(name, value, propertyName);
        }
        protected abstract eTextOptions GetTextOptions(string logicalName);
        protected abstract string GetErrorString(string attributeName, eErrorType defaultErrorType);
        protected abstract eNumberOptions GetNumberOptions(string logicalName);
        public bool IsDirty
        {
            get { return this._changedValues.Count > 0; }
        }
        public static List<T> GetRelatedOneToManyEntities<T>(IOrganizationService service, Guid relatedId, string logicalName, string attributeName, params string[] columns) where T : BaseProxyClass
        {
            return GetRelatedOneToManyEntities(service, relatedId, logicalName, attributeName, columns).ToProxies<T>();
        }
        public static List<T> GetRelatedOneToManyEntities<T>(IOrganizationService service, Guid relatedId, string logicalName, string attributeName, ColumnSet columns) where T : BaseProxyClass
        {
            return GetRelatedOneToManyEntities(service, relatedId, logicalName, attributeName, columns).ToProxies<T>();
        }
        public static List<Entity> GetRelatedOneToManyEntities(IOrganizationService service, Guid relatedId, string logicalName, string attributeName, params string[] columns)
        {
            return GetRelatedOneToManyEntities(service, relatedId, logicalName, attributeName, ExtensionMethods.GetColumnSet(columns));
        }
        public static List<Entity> GetRelatedOneToManyEntities(IOrganizationService service, Guid relatedId, string logicalName, string attributeName, ColumnSet columns)
        {
            return service.RetrieveMultiple(logicalName, new ConditionExpression(attributeName, ConditionOperator.Equal, relatedId), columns).Entities.ToList();
        }
        public static List<T> GetRelatedManyToManyEntities<T>(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, params string[] columns) where T : BaseProxyClass
        {
            return GetRelatedManyToManyEntities(service, proxy, linkFromEntityTypeName, linkFromAttributeName, linkToEntityTypeName, linkToAttributeName, intermediateEntityName, intermediateFromAttributeName, intermediateToAttributeName, columns).ToProxies<T>();
        }
        public static List<T> GetRelatedManyToManyEntities<T>(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, ColumnSet columns) where T : BaseProxyClass
        {
            return GetRelatedManyToManyEntities(service, proxy, linkFromEntityTypeName, linkFromAttributeName, linkToEntityTypeName, linkToAttributeName, intermediateEntityName, intermediateFromAttributeName, intermediateToAttributeName, columns).ToProxies<T>();
        }
        public static List<Entity> GetRelatedManyToManyEntities(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, params string[] columns)
        {
            return GetRelatedManyToManyEntities(service, proxy, linkFromEntityTypeName, linkFromAttributeName, linkToEntityTypeName, linkToAttributeName, intermediateEntityName, intermediateFromAttributeName, intermediateToAttributeName, ExtensionMethods.GetColumnSet(columns));
        }
        public static List<Entity> GetRelatedManyToManyEntities(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, ColumnSet columns)
        {
            var query = new QueryExpression()
            {
                EntityName = linkToEntityTypeName,
                ColumnSet = columns,
                LinkEntities = {
                    new LinkEntity(){
                        LinkFromAttributeName = linkToAttributeName,
                        LinkFromEntityName = linkToEntityTypeName,
                        LinkToAttributeName = intermediateToAttributeName,
                        LinkToEntityName = intermediateEntityName,
                        LinkEntities = {
                            new LinkEntity(){
                                LinkFromAttributeName = intermediateFromAttributeName,
                                LinkFromEntityName = intermediateEntityName,
                                LinkToAttributeName = linkFromAttributeName,
                                LinkToEntityName = linkFromEntityTypeName,
                                LinkCriteria = new FilterExpression(){
                                    Conditions = {
                                        new ConditionExpression(linkFromAttributeName, ConditionOperator.Equal, new object[]{ proxy.Id })
                                    }
                                }
                            }
                        }
                    }
                }
            };

            return service.RetrieveMultiple(query).Entities.ToList();
        }
        private class AttributeEqualityComparer : IEqualityComparer
        {
            public new bool Equals(object x, object y)
            {
                if ((x == null || (x.GetType() == typeof(string) && string.IsNullOrEmpty(x as string))) && (y == null || (y.GetType() == typeof(string) && string.IsNullOrEmpty(y as string))))
                    return true;
                else
                {
                    if (x == null && y == null) { return true; }
                    else if (x == null && y != null) { return false; }
                    else if (x != null && y == null) { return false; }
                    else if (x.GetType() == y.GetType())
                    {
                        if (x.GetType() == typeof(OptionSetValue)) { return ((OptionSetValue)x).Value == ((OptionSetValue)y).Value; }
                        else if (x.GetType() == typeof(BooleanManagedProperty)) { return ((BooleanManagedProperty)x).Value == ((BooleanManagedProperty)y).Value; }
                        else if (x.GetType() == typeof(EntityReference))
                        {
                            if (((EntityReference)x).LogicalName == ((EntityReference)y).LogicalName) { return ((EntityReference)x).Id == ((EntityReference)y).Id; }
                            else { return false; }
                        }
                        else if (x.GetType() == typeof(Money)) { return (((Money)x).Value == ((Money)y).Value); }
                        else if (x.GetType() == typeof(DateTime) || x.GetType() == typeof(DateTime?))
                        {
                            //Compare only down to the second since CRM only tracks down to the second
                            return Math.Abs(((DateTime)x - (DateTime)y).TotalSeconds) < 1;
                        }
                        else { return x.Equals(y); }
                    }
                    else { return false; }
                }
            }
            public int GetHashCode(object obj)
            {
                return obj.GetHashCode();
            }
        }
        public enum eTextOptions
        {
            /// <summary>Ignore and let CRM handle any issues with the value</summary>
            Ignore,
            /// <summary>If the length is greater than the max length, truncate the value to the max length</summary>
            Truncate,
            /// <summary>Throw an error if the length of the value is greater than the max length</summary>
            ThrowError
        }
        public enum eNumberOptions
        {
            /// <summary>Ignore and let CRM handle any issues with the value.</summary>
            Ignore,
            /// <summary>If the value is less than the min value set the value as the min value.<para>Let CRM handle any issues with the max value.</para></summary>
            CorrectMinIgnoreMax,
            /// <summary>If the value is less than the min value set the value as the min value.<para>Throw an error if the value is greater than the max value.</para></summary>
            CorrectMinThrowMax,
            /// <summary>If the value is greater than the max value set the value as the max value.<para>Let CRM handle any issues with the min value.</para></summary>
            CorrectMaxIgnoreMin,
            /// <summary>If the value is greater than the max value set the value as the max value.<para>Throw an error if the value is less than the min value.</para></summary>
            CorrectMaxThrowMin,
            /// <summary>If the value is less than the min value set the value as the min value.<para>If the value is greater than the max value set the value as the max value.</para></summary>
            CorrectMinAndMax,
            /// <summary>Throw an error if the value is less than the min or greater than the max</summary>
            ThrowError
        }
        public enum eErrorType
        {
            Text,
            Number
        }
        public event PropertyChangedEventHandler PropertyChanged;
        public event PropertyChangingEventHandler PropertyChanging;
    }

    public static partial class ExtensionMethods
    {
        public static Guid Create(this IOrganizationService service, BaseProxyClass proxy)
        {
            proxy.Id = service.Create(proxy);
            return proxy.Id;
        }
        public static void Update(this IOrganizationService service, BaseProxyClass proxy)
        {
            proxy.Update(service);
        }
        public static void Delete(this IOrganizationService service, BaseProxyClass proxy)
        {
            service.Delete(proxy.LogicalName, proxy.Id);
        }
        public static void SetState(this IOrganizationService service, BaseProxyClass proxy, int state, int status)
        {
            service.SetState(proxy, new OptionSetValue(state), new OptionSetValue(status));
        }
        public static void SetState(this IOrganizationService service, BaseProxyClass proxy, OptionSetValue state, OptionSetValue status)
        {
            var request = new SetStateRequest() { EntityMoniker = proxy, State = state, Status = status };
            service.Execute(request);
        }
        public async static System.Threading.Tasks.Task<Guid> CreateAsync(this IOrganizationService service, Entity entity)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                entity.Id = service.Create(entity);
                return entity.Id;
            });
        }
        public async static System.Threading.Tasks.Task UpdateAsync(this IOrganizationService service, Entity entity)
        {
            await System.Threading.Tasks.Task.Run(() =>
            {
                service.Update(entity);
                return;
            });
        }
        public async static System.Threading.Tasks.Task DeleteAsync(this IOrganizationService service, Entity entity)
        {
            await DeleteAsync(service, entity.LogicalName, entity.Id);
        }
        public async static System.Threading.Tasks.Task<OrganizationResponse> ExecuteAsync(this IOrganizationService service, OrganizationRequest request)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                return service.Execute(request);
            });
        }
        public async static System.Threading.Tasks.Task SetStateAsync(this IOrganizationService service, BaseProxyClass proxy, int state, int status)
        {
            await service.SetStateAsync(proxy, new OptionSetValue(state), new OptionSetValue(status));
        }
        public async static System.Threading.Tasks.Task SetStateAsync(this IOrganizationService service, BaseProxyClass proxy, OptionSetValue state, OptionSetValue status)
        {
            var request = new SetStateRequest() { EntityMoniker = proxy, State = state, Status = status };
            await service.ExecuteAsync(request);
        }
        public static T ToProxy<T>(this EntityReference reference) where T : BaseProxyClass
        {
            if (reference == null) { return null; }
            return reference.ToEntity().ToProxy<T>();
        }
        public static Entity ToEntity(this EntityReference reference)
        {
            if (reference == null) { return null; }
            return new Entity() { LogicalName = reference.LogicalName, Id = reference.Id };
        }
        public static T ToProxy<T>(this Entity entity) where T : BaseProxyClass
        {
            if (entity != null)
            {
                var constructor = typeof(T).GetConstructor(new Type[] { typeof(Entity) });
                return entity.ToProxy<T>(constructor);
            }
            return null;
        }
        private static T ToProxy<T>(this Entity entity, ConstructorInfo construcor) where T : BaseProxyClass
        {
            return construcor.Invoke(new object[] { entity }) as T;
        }
        public static AttributeMetadata GetAttributeMetadata(this IOrganizationService service, string entityLogicalName, string attributeLogicalName)
        {
            var request = new RetrieveAttributeRequest() { EntityLogicalName = entityLogicalName, LogicalName = attributeLogicalName };
            return (service.Execute(request) as RetrieveAttributeResponse).AttributeMetadata;
        }
        public static OptionMetadata GetOptionMetadata(this OptionSetValue value, IOrganizationService service, BaseProxyClass entity, string attributeLogicalName)
        {
            var attributeMeta = service.GetAttributeMetadata(entity.LogicalName, attributeLogicalName);
            if (attributeMeta is EnumAttributeMetadata)
                return ((EnumAttributeMetadata)attributeMeta).GetOptionMetadata(value.Value);
            else { throw new Exception("The attribute is not an Enum type attribute"); }
        }
        public static OptionMetadata GetOptionMetadata(this EnumAttributeMetadata enumMeta, int value)
        {
            return (from meta in enumMeta.OptionSet.Options where meta.Value == value select meta).FirstOrDefault();
        }
        public static string GetOptionSetText(this EnumAttributeMetadata enumMeta, int value)
        {
            return enumMeta.GetOptionMetadata(value).GetOptionSetText();
        }
        public static string GetOptionSetText(this OptionSetValue value, IOrganizationService service, BaseProxyClass entity, string attributeLogicalName)
        {
            var optionMeta = GetOptionMetadata(value, service, entity, attributeLogicalName);
            return optionMeta.GetOptionSetText();
        }
        public static string GetOptionSetText(this OptionMetadata optionMeta)
        {
            if (optionMeta != null && optionMeta.Label != null && optionMeta.Label.UserLocalizedLabel != null) { return optionMeta.Label.UserLocalizedLabel.Label; }
            return string.Empty;
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService service, ConditionExpression expression, ColumnSet columns) where T : BaseProxyClass
        {
            var filterExpression = new FilterExpression();
            filterExpression.AddCondition(expression);
            return service.RetrieveProxies<T>(filterExpression, columns);
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService service, FilterExpression expression, ColumnSet columns) where T : BaseProxyClass
        {
            var query = new QueryExpression(BaseProxyClass.GetLogicalName<T>()) { ColumnSet = columns, Criteria = expression };
            return service.RetrieveProxies<T>(query);
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService service, params string[] columns) where T : BaseProxyClass
        {
            return service.RetrieveProxies<T>(GetColumnSet(columns));
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService service, ColumnSet columns) where T : BaseProxyClass
        {
            var query = new QueryExpression(BaseProxyClass.GetLogicalName<T>()) { ColumnSet = columns };
            return service.RetrieveMultipleAllPages(query).ToProxies<T>();
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService service, QueryExpression query) where T : BaseProxyClass
        {
            return service.RetrieveMultipleAllPages(query).ToProxies<T>();
        }
        public static List<T> ToProxies<T>(this EntityCollection entities) where T : BaseProxyClass
        {
            return entities.Entities.ToProxies<T>();
        }
        public static List<T> ToProxies<T>(this IEnumerable<Entity> entities) where T : BaseProxyClass
        {
            var constructor = typeof(T).GetConstructor(new Type[] { typeof(Entity) });
            return (from entity in entities select entity.ToProxy<T>(constructor)).ToList();
        }
        public static T RetrieveProxy<T>(this EntityReference entity, IOrganizationService service, params string[] columns) where T : BaseProxyClass
        {
            return service.RetrieveProxy<T>(entity.Id, columns);
        }
        public static T RetrieveProxy<T>(this EntityReference entity, IOrganizationService service, ColumnSet columns) where T : BaseProxyClass
        {
            return service.RetrieveProxy<T>(entity.Id, columns);
        }
        public static T RetrieveProxy<T>(this IOrganizationService service, Guid Id, params string[] columns) where T : BaseProxyClass
        {
            var entityName = BaseProxyClass.GetLogicalName<T>();
            return RetrieveEntity(new EntityReference(entityName, Id), service, columns).ToProxy<T>();
        }
        public static T RetrieveProxy<T>(this IOrganizationService service, Guid Id, ColumnSet columns) where T : BaseProxyClass
        {
            var entityName = BaseProxyClass.GetLogicalName<T>();
            return RetrieveEntity(new EntityReference(entityName, Id), service, columns).ToProxy<T>();
        }
        public static T FindProxy<T>(this IOrganizationService service, string propertyName, object value, params string[] columns) where T : BaseProxyClass
        {
            return service.FindProxy<T>(propertyName, value, GetColumnSet(columns));
        }
        public static T FindProxy<T>(this IOrganizationService service, string propertyName, object value, ColumnSet columns) where T : BaseProxyClass
        {
            return service.FindProxies<T>(propertyName, value, columns).FirstOrDefault();
        }
        public static T FindProxy<T>(this IOrganizationService service, string propertyName, ConditionOperator Operator, object value, params string[] columns) where T : BaseProxyClass
        {
            return service.FindProxy<T>(propertyName, Operator, value, GetColumnSet(columns));
        }
        public static T FindProxy<T>(this IOrganizationService service, string propertyName, ConditionOperator Operator, object value, ColumnSet columns) where T : BaseProxyClass
        {
            return service.FindProxies<T>(propertyName, Operator, value, columns).FirstOrDefault();
        }
        public static List<T> FindProxies<T>(this IOrganizationService service, string propertyName, object value, params string[] columns) where T : BaseProxyClass
        {
            return service.FindProxies<T>(propertyName, value, GetColumnSet(columns));
        }
        public static List<T> FindProxies<T>(this IOrganizationService service, string propertyName, object value, ColumnSet columns) where T : BaseProxyClass
        {
            return service.FindProxies<T>(propertyName, ConditionOperator.Equal, value, columns);
        }
        public static List<T> FindProxies<T>(this IOrganizationService service, string propertyName, ConditionOperator @operator, object value, params string[] columns) where T : BaseProxyClass
        {
            return service.FindProxies<T>(propertyName, @operator, value, GetColumnSet(columns));
        }
        public static List<T> FindProxies<T>(this IOrganizationService service, string propertyName, ConditionOperator @operator, object value, ColumnSet columns) where T : BaseProxyClass
        {
            var propertyCondition = value != null ? new ConditionExpression(propertyName, @operator, value) : new ConditionExpression(propertyName, @operator);
            return service.RetrieveProxies<T>(propertyCondition, columns);
        }
        internal static ColumnSet GetColumnSet(params string[] columns)
        {
            var columnSet = new ColumnSet(columns);
            if (columnSet.Columns.Count == 0) { columnSet = new ColumnSet(true); }
            return columnSet;
        }
        public static Entity RetrieveEntity(this EntityReference entity, IOrganizationService service, params string[] columns)
        {
            return entity.RetrieveEntity(service, GetColumnSet(columns));
        }
        public static Entity RetrieveEntity(this EntityReference entity, IOrganizationService service, ColumnSet columns)
        {
            if (columns == null) { columns = new ColumnSet(true); }
            return service.Retrieve(entity.LogicalName, entity.Id, columns);
        }
        public static EntityCollection RetrieveMultiple(this IOrganizationService service, string logicalName, ConditionExpression condition, params string[] columns)
        {
            return service.RetrieveMultiple(logicalName, condition, GetColumnSet(columns));
        }
        public static EntityCollection RetrieveMultiple(this IOrganizationService service, string logicalName, ConditionExpression condition, ColumnSet columns)
        {
            var query = new QueryExpression(logicalName) { ColumnSet = columns };
            query.Criteria.AddCondition(condition);
            return service.RetrieveMultipleAllPages(query);
        }
        public static bool RetrieveAllPages = true;
        public static EntityCollection RetrieveMultipleAllPages(this IOrganizationService service, QueryExpression query)
        {
            var results = service.RetrieveMultiple(query);
            while (results.MoreRecords && RetrieveAllPages)
            {
                var currentResults = results.Entities;
                query.PageInfo.PagingCookie = results.PagingCookie;
                query.PageInfo.PageNumber += 1;
                results = service.RetrieveMultiple(query);
                results.Entities.AddRange(currentResults);
            }
            return results;
        }
        public static void RelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, IList<Entity> entities)
        {
            service.RelateEntities(target, intermediateEntityName, entities.ToArray());
        }
        public static void RelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, params Entity[] entities)
        {
            var references = (from EntityTemp in entities select EntityTemp.ToEntityReference()).ToList();
            service.RelateEntities(target, intermediateEntityName, references);
        }
        public static void RelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, IList<EntityReference> entities)
        {
            service.RelateEntities(target, intermediateEntityName, entities.ToArray());
        }
        public static void RelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, params EntityReference[] entities)
        {
            var request = new AssociateRequest()
            {
                Relationship = new Relationship(intermediateEntityName),
                Target = target,
            };
            request.RelatedEntities = new EntityReferenceCollection(entities);
            service.Execute(request);
        }
        public static void UnRelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, IList<Entity> entities)
        {
            service.UnRelateEntities(target, intermediateEntityName, entities.ToArray());
        }
        public static void UnRelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, params Entity[] entities)
        {
            var references = (from EntityTemp in entities select EntityTemp.ToEntityReference()).ToList();
            service.UnRelateEntities(target, intermediateEntityName, references);
        }
        public static void UnRelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, IList<EntityReference> entities)
        {
            service.UnRelateEntities(target, intermediateEntityName, entities.ToArray());
        }
        public static void UnRelateEntities(this IOrganizationService service, EntityReference target, string intermediateEntityName, params EntityReference[] entities)
        {
            var request = new DisassociateRequest()
            {
                Target = target,
                Relationship = new Relationship(intermediateEntityName)
            };
            request.RelatedEntities = new EntityReferenceCollection(entities);
            service.Execute(request);
        }
        public static void Add(this List<OrganizationRequest> requests, BaseProxyClass proxy)
        {
            var request = GetOrganizationRequest(proxy);
            if (request != null) { requests.Add(request); }
        }
        public static void Add(this OrganizationRequestCollection collection, BaseProxyClass proxy)
        {
            var request = GetOrganizationRequest(proxy);
            if (request != null) { collection.Add(request); }
        }
        public static OrganizationRequest GetOrganizationRequest(BaseProxyClass proxy)
        {
            if (proxy.Id != Guid.Empty && proxy.IsDirty)
                return new UpdateRequest() { Target = proxy.GetChangedEntity() };
            else if (proxy.Id == Guid.Empty)
                return new CreateRequest() { Target = proxy };
            return null;
        }
        public static void GrantAccess(this IAccessControlledEntity entity, IOrganizationService service, EntityReference principal, AccessRights accessMask)
        {
            var request = new GrantAccessRequest() { PrincipalAccess = new PrincipalAccess() { Principal = principal, AccessMask = accessMask }, Target = (EntityReference)(object)entity };
            service.Execute(request);
        }
        public static void ModifyAccess(this IAccessControlledEntity entity, IOrganizationService service, EntityReference Principal, AccessRights AccessMask)
        {
            var request = new ModifyAccessRequest() { PrincipalAccess = new PrincipalAccess() { Principal = Principal, AccessMask = AccessMask }, Target = (EntityReference)(object)entity };
            service.Execute(request);
        }
        public static void RevokeAccess(this IAccessControlledEntity entity, IOrganizationService service, EntityReference revokee)
        {
            var request = new RevokeAccessRequest() { Revokee = revokee, Target = (EntityReference)(object)entity };
            service.Execute(request);
        }
        private static Dictionary<string, Dictionary<Guid, Entity>> _cachedEntities = new Dictionary<string, Dictionary<Guid, Entity>>();
        public static void ClearCache(string entityLogicalName = null)
        {
            lock (_cachedEntities)
            {
                if (!string.IsNullOrEmpty(entityLogicalName))
                    if (_cachedEntities.ContainsKey(entityLogicalName)) { _cachedEntities[entityLogicalName] = new Dictionary<Guid, Entity>(); }
                    else { _cachedEntities.Clear(); }
            }
        }
        public static Entity RetrieveCachedEntityById(this IOrganizationService service, string entityLogicalName, Guid Id, ColumnSet columns)
        {
            lock (_cachedEntities)
            {
                Entity CachedEntity = GetEntityFromCache(entityLogicalName, Id);
                if (CachedEntity == null)
                {
                    CachedEntity = service.Retrieve(entityLogicalName, Id, columns);
                    AddEntityToCache(CachedEntity);
                }
                return CachedEntity;
            }
        }
        public static Entity GetEntityFromCache(this IOrganizationService service, string entityLogicalName, Guid id)
        {
            return GetEntityFromCache(entityLogicalName, id);
        }
        public static Entity GetEntityFromCache(string entityLogicalName, Guid id)
        {
            lock (_cachedEntities)
            {
                Entity CachedEntity = null;
                Dictionary<Guid, Entity> cachedEntities = GetEntitiesFromCache(entityLogicalName);
                cachedEntities.TryGetValue(id, out CachedEntity);
                return CachedEntity;
            }
        }
        public static Dictionary<Guid, Entity> GetEntitiesFromCache(this IOrganizationService service, string entityLogicalName)
        {
            return GetEntitiesFromCache(entityLogicalName);
        }
        public static Dictionary<Guid, Entity> GetEntitiesFromCache(string entityLogicalName)
        {
            lock (_cachedEntities)
            {
                var cachedEntities = new Dictionary<Guid, Entity>();
                _cachedEntities.TryGetValue(entityLogicalName, out cachedEntities);
                return cachedEntities != null ? cachedEntities : new Dictionary<Guid, Entity>();
            }
        }
        public static void AddEntitiesToCache<T>(this IOrganizationService service, ICollection<T> entities) where T : BaseProxyClass
        {
            foreach (T entity in entities) { AddEntityToCache(entity); }
        }
        public static void AddEntitiesToCache(this IOrganizationService service, ICollection<Entity> entities)
        {
            AddEntitiesToCache(entities);
        }
        public static void AddEntitiesToCache(ICollection<Entity> entities)
        {
            lock (_cachedEntities)
            {
                foreach (Entity entity in entities)
                    AddEntityToCache(entity);
            }
        }
        public static void AddEntityToCache(this IOrganizationService service, Entity entity)
        {
            AddEntityToCache(entity);
        }
        public static void AddEntityToCache(Entity entity)
        {
            lock (_cachedEntities)
            {
                if (!_cachedEntities.ContainsKey(entity.LogicalName))
                    _cachedEntities.Add(entity.LogicalName, new Dictionary<Guid, Entity> { });
                if (!_cachedEntities[entity.LogicalName].ContainsKey(entity.Id))
                    _cachedEntities[entity.LogicalName].Add(entity.Id, entity);
            }
        }
        public static T RetrieveCachedProxy<T>(this IOrganizationService service, EntityReference entity) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(service, entity, new ColumnSet(true));
        }
        public static T RetrieveCachedProxy<T>(this IOrganizationService service, EntityReference entity, params string[] columns) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(service, entity, GetColumnSet(columns));
        }
        public static T RetrieveCachedProxy<T>(this IOrganizationService service, EntityReference entity, ColumnSet columns) where T : BaseProxyClass
        {
            return RetrieveCachedEntityById(service, entity.LogicalName, entity.Id, columns).ToProxy<T>();
        }
        public static T RetrieveCachedProxy<T>(this EntityReference entity, IOrganizationService service) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(entity, service, new ColumnSet(true));
        }
        public static T RetrieveCachedProxy<T>(this EntityReference entity, IOrganizationService service, params string[] columns) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(entity, service, GetColumnSet(columns));
        }
        public static T RetrieveCachedProxy<T>(this EntityReference entity, IOrganizationService service, ColumnSet columns) where T : BaseProxyClass
        {
            return service.RetrieveCachedProxy<T>(entity, columns);
        }
        public async static System.Threading.Tasks.Task<EntityMetadata> GetEntityMetadataAsync(this IOrganizationService service, string logicalName, EntityFilters filters)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                return GetEntityMetadata(service, logicalName, filters);
            });
        }
        public static EntityMetadata GetEntityMetadata(this IOrganizationService service, string logicalName, EntityFilters filters)
        {
            var request = new RetrieveEntityRequest() { LogicalName = logicalName, EntityFilters = filters };
            return ((RetrieveEntityResponse)service.Execute(request)).EntityMetadata;
        }
        public async static System.Threading.Tasks.Task<Entity> RetrieveAsync(this IOrganizationService service, string entityName, Guid id, params string[] columns)
        {
            return await service.RetrieveAsync(entityName, id, GetColumnSet(columns));
        }
        public async static System.Threading.Tasks.Task<Entity> RetrieveAsync(this IOrganizationService service, EntityReference entity, params string[] columns)
        {
            return await service.RetrieveAsync(entity.LogicalName, entity.Id, GetColumnSet(columns));
        }
        public async static System.Threading.Tasks.Task<Entity> RetrieveAsync(this IOrganizationService service, EntityReference entity, ColumnSet columns)
        {
            return await service.RetrieveAsync(entity.LogicalName, entity.Id, columns);
        }
        public async static System.Threading.Tasks.Task<Entity> RetrieveAsync(this IOrganizationService service, string entityName, Guid id, ColumnSet columns)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                return service.Retrieve(entityName, id, columns);
            });
        }
        public static void CopyTo(this Entity entity, Entity toEntity, bool overwriteMissingValuesOnly = true)
        {
            if (entity.Id != Guid.Empty && (toEntity.Id == Guid.Empty || !overwriteMissingValuesOnly)) toEntity.Id = entity.Id;
            foreach (var attribute in entity.Attributes)
            {
                if (!toEntity.Contains(attribute.Key) || !overwriteMissingValuesOnly)
                    toEntity[attribute.Key] = attribute.Value;
            }
        }
        public async static System.Threading.Tasks.Task<EntityCollection> RetrieveMultipleAsync(this IOrganizationService service, QueryExpression query)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                return service.RetrieveMultiple(query);
            });
        }
        public async static System.Threading.Tasks.Task<EntityCollection> RetrieveMultipleAsync(this IOrganizationService service, string entityName, ConditionExpression condition, ColumnSet columns)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                return service.RetrieveMultiple(entityName, condition, columns);
            });
        }
        public async static System.Threading.Tasks.Task<EntityCollection> RetrieveMultipleAsync(this IOrganizationService service, string entityName, ConditionExpression condition, params string[] columns)
        {
            return await System.Threading.Tasks.Task.Run(() =>
            {
                return service.RetrieveMultiple(entityName, condition, columns);
            });
        }
        public async static System.Threading.Tasks.Task DeleteAsync(this IOrganizationService service, EntityReference entity)
        {
            await DeleteAsync(service, entity.LogicalName, entity.Id);
        }
        public async static System.Threading.Tasks.Task DeleteAsync(this IOrganizationService service, string logicalName, Guid id)
        {
            await System.Threading.Tasks.Task.Run(() =>
            {
                service.Delete(logicalName, id);
            });
        }
    }
    public interface IAccessControlledEntity { }
}